/* IP connection tracking helpers. */
#ifndef _IP_CONNTRACK_HELPER_H
#define _IP_CONNTRACK_HELPER_H
#include "ip_conntrack.h"

struct module;

struct ip_conntrack_helper
{	
	/* Internal use. */
	struct list_head list;

	/* Here's the protocol and src (of reply) we care about. */
	u_int16_t protocol;
	union ip_conntrack_manip_proto protocol_reply;

	/* Function to call when data passes; return verdict. */
	unsigned int (*help)(const struct iphdr *, size_t len,
			     struct ip_conntrack_tuple_hash *h,
			     enum ip_conntrack_info *conntrackinfo);
};

extern int ip_conntrack_helper_register(struct ip_conntrack_helper *);
extern void ip_conntrack_helper_unregister(struct ip_conntrack_helper *);
#endif /*_IP_CONNTRACK_HELPER_H*/
