#! /bin/sh
# Test of the various hooks.

# Job control required
set -m

TMPFILE2=`tempfile`

# We steal a packet and down the interface: it should NOT go through.
insmod ../tools/redirect.o hook=2 || exit 1

../tools/intercept FORWARD ACCEPT 6 1 2 | ../tools/rcv_ip 2 1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
sleep 1

ifconfig tap1 down || exit 1

if ../tools/rcv_ip 4 1 < /dev/tap1 > $TMPFILE2
then
    echo ../tools/rcv_ip succeeded after downed interface.
    cat $TMPFILE2
    rm -f $TMPFILE2
    exit 1
fi

rm -f $TMPFILE2

if wait %../tools/intercept; then :
else
    echo Intercept failed:
    cat $TMPFILE
    exit 1
fi

# Restore interface
ifconfig tap1 $TAP1 || exit 1
rmmod redirect || exit 1

exit 0

