#! /bin/sh
# Shell script to run iptables test suite.

START_FILE=$1
for f in 00netfilter/[0-9]*
do
    if [ -z "$START_FILE" -o $f = "$START_FILE" ]
    then
	insmod ../device/netfilter_dev.o || exit 1

	if $f
	then
	    [ -z "$VERBOSE" ] || echo Test $f succeeded.
	else
	    echo Test $f failed.
	    exit 1
	fi
	rmmod netfilter_dev || exit 1
	rmmod redirect 2>/dev/null

	logs_check $f
	START_FILE=""
    else
	[ -z "$VERBOSE" ] || echo Skipping test $f.
    fi
done

exit 0
