#! /bin/sh

# Test rule append.
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -N REJECT || exit 1
../packet-filter/userspace/iptables -N MASQ || exit 1
../packet-filter/userspace/iptables -N REDIRECT || exit 1

../packet-filter/userspace/iptables -A foo -j DROP || exit 1
../packet-filter/userspace/iptables -A foo -j REJECT || exit 1
../packet-filter/userspace/iptables -A foo -j ACCEPT || exit 1

# Test list of all.
if [ "`../packet-filter/userspace/iptables -L | tr -s '\\012 ' ' '`" != "Chain INPUT (policy ACCEPT) target prot opt source destination Chain FORWARD (policy DROP) target prot opt source destination Chain OUTPUT (policy ACCEPT) target prot opt source destination Chain foo (0 references) target prot opt source destination DROP all -- anywhere anywhere REJECT all -- anywhere anywhere ACCEPT all -- anywhere anywhere Chain REJECT (1 references) target prot opt source destination Chain MASQ (0 references) target prot opt source destination Chain REDIRECT (0 references) target prot opt source destination " ]
then
    echo Unexpected iptables -L.
    ../packet-filter/userspace/iptables -L | tr '\012 ' ' '
    exit 1
fi

# Test list of foo only.
if [ "`../packet-filter/userspace/iptables -L foo`" != "Chain foo (0 references)
target     prot opt source               destination         
DROP       all  --  anywhere             anywhere           
REJECT     all  --  anywhere             anywhere           
ACCEPT     all  --  anywhere             anywhere           " ]
then
    echo Unexpected iptables -L foo output.
    exit 1
fi

