#! /bin/sh

# Test insert.
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -N REJECT || exit 1
../packet-filter/userspace/iptables -N MASQ || exit 1
../packet-filter/userspace/iptables -N REDIRECT || exit 1

../packet-filter/userspace/iptables -I foo -j RETURN || exit 1
if [ "`../packet-filter/userspace/iptables -L foo | grep -n ^RETURN`" != "3:RETURN     all  --  anywhere             anywhere           " ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 3 ]
then
    echo Unexpected iptables -L foo output after RETURN.
    exit 1
fi

../packet-filter/userspace/iptables -I foo 1 -j MASQ || exit 1
if [ "`../packet-filter/userspace/iptables -L foo | grep -n ^MASQ`" != "3:MASQ       all  --  anywhere             anywhere           " ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 4 ]
then
    echo Unexpected iptables -L foo output after MASQ
    exit 1
fi

# Insert past end must fail.
../packet-filter/userspace/iptables -I foo 4 2>/dev/null && exit 1

../packet-filter/userspace/iptables -I foo 3 -j REDIRECT || exit 1

if [ "`../packet-filter/userspace/iptables -L foo | grep -n ^REDIRECT`" != "5:REDIRECT   all  --  anywhere             anywhere           " ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 5 ]
then
    echo Unexpected iptables -L foo output after REDIRECT
    exit 1
fi

../packet-filter/userspace/iptables -I foo 2 || exit 1

if [ "`../packet-filter/userspace/iptables -L foo | grep -n '^ '`" != "4:           all  --  anywhere             anywhere           " ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 6 ]
then
    echo Unexpected iptables -L foo output after -I 2
    exit 1
fi

# Deletion tests.
../packet-filter/userspace/iptables -D foo 5 2>/dev/null && exit 1
../packet-filter/userspace/iptables -D foo 4 || exit 1
if [ "`../packet-filter/userspace/iptables -L foo | grep -n '^REDIRECT'`" != "" ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 5 ]
then
    echo Unexpected iptables -L foo output after -D 4
    exit 1
fi

../packet-filter/userspace/iptables -D foo 2 || exit 1
if [ "`../packet-filter/userspace/iptables -L foo | grep -n ^REJECT`" != "" ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 4 ]
then
    echo Unexpected iptables -L foo output after -D 5
    exit 1
fi

../packet-filter/userspace/iptables -D foo -j RETURN || exit 1
if [ "`../packet-filter/userspace/iptables -L foo | grep -n ^RETURN`" != "" ] || [ `../packet-filter/userspace/iptables -L foo | wc -l` != 3 ]
then
    echo Unexpected iptables -L foo output after -D RETURN
    exit 1
fi

exit 0
