#! /bin/sh

# Need job control.
set -m

# Test the various different protocol match possibilities.

for i in "" "-p icmp" "-p 1" "-p ! 2"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j ACCEPT || exit 1
    ../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %../tools/rcv_ip; then :
    else
	echo ../tools/rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
for i in "-p ! icmp" "-p ! 1" "-p 2"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j DROP || exit 1
    ../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %../tools/rcv_ip; then :
    else
	echo ../tools/rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

exit 0
