#! /bin/sh

# BUG 03 - Thanks to Graham Murray's report.

set -e

insmod ../packet-filter/extensions/ipt_tcp.o
insmod ../packet-filter/extensions/ipt_udp.o
insmod ../packet-filter/extensions/ipt_icmp.o
insmod ../packet-filter/extensions/ipt_LOG.o

IPTABLES=../packet-filter/userspace/iptables

# create the ppp table
$IPTABLES -N ppp

# setup the input chain
$IPTABLES -A INPUT -i ppp0 -j ppp     
$IPTABLES -A INPUT -i lo -p udp --dport 53 -j ACCEPT
$IPTABLES -A INPUT -i lo -p tcp --dport 53 -j ACCEPT
$IPTABLES -A INPUT -i lo -j ACCEPT                  

# setup the ppp table
# TCP rules
$IPTABLES -A ppp -p tcp -s 194.217.242.0/24 --dport 25 -j ACCEPT
$IPTABLES -A ppp -p tcp --dport 113 -j ACCEPT
$IPTABLES -A ppp -p tcp --dport 79 -j ACCEPT 
$IPTABLES -A ppp -p tcp --sport 53 -j ACCEPT 
$IPTABLES -A ppp -p tcp --dport 1080 --syn -j LOG
$IPTABLES -A ppp -p tcp --dport 1080 --syn -j DROP
$IPTABLES -A ppp -p tcp --dport 8080 --syn -j LOG  --log-level notice
$IPTABLES -A ppp -p tcp --dport 8080 --syn -j DROP 
$IPTABLES -A ppp -p tcp --dport 0:1024 --syn -j LOG
$IPTABLES -A ppp -p tcp --dport 0:1024 --syn -j DROP
$IPTABLES -A ppp -p tcp --dport 6000:6010 -j LOG  --log-level alert
$IPTABLES -A ppp -p tcp --dport 6000:6010 -j DROP
$IPTABLES -A ppp -p tcp -j ACCEPT 

# UDP rules
$IPTABLES -A ppp -p udp --dport 53 -j ACCEPT
$IPTABLES -A ppp -p udp --sport 53 -j ACCEPT
$IPTABLES -A ppp -p udp --sport 4000 -j ACCEPT
$IPTABLES -A ppp -p udp --sport 37 -j ACCEPT
$IPTABLES -A ppp -p udp --dport 137 -j LOG
$IPTABLES -A ppp -p udp -j DROP

# ICMP rules
$IPTABLES -A ppp -p icmp --icmp-type redirect -j DROP
$IPTABLES -A ppp -p icmp -j ACCEPT 

if [ `$IPTABLES -L -n | wc -l` != 36 ]
then
    echo Unexpected iptables -L -n output:
    $IPTABLES -L -n
    exit 1
fi

$IPTABLES -F

rmmod ipt_tcp
rmmod ipt_udp
rmmod ipt_icmp
rmmod ipt_LOG

exit 0






