#! /bin/sh

# BUG 0010 - Thanks to Adam Kumiszcza's report.
set -e

insmod ../packet-filter/extensions/ipt_LOG.o
insmod ../packet-filter/extensions/ipt_icmp.o
insmod ../packet-filter/extensions/ipt_tcp.o
insmod ../packet-filter/extensions/ipt_udp.o

../packet-filter/userspace/iptables -N PPP
../packet-filter/userspace/iptables -N LOGDROP
../packet-filter/userspace/iptables -A INPUT -i ppp0 -j PPP
../packet-filter/userspace/iptables -A PPP -s 10.0.0.0/8 -j LOGDROP
../packet-filter/userspace/iptables -A PPP -s 127.0.0.0/8 -j LOGDROP
../packet-filter/userspace/iptables -A PPP -s 192.168.0.0/16 -j LOGDROP
../packet-filter/userspace/iptables -A PPP -s 172.16.0.0/16 -j LOGDROP
../packet-filter/userspace/iptables -A PPP -p tcp --dport 25 -j ACCEPT
../packet-filter/userspace/iptables -A PPP -s 195.116.50.204 -j ACCEPT
../packet-filter/userspace/iptables -A PPP -s 195.116.50.3 -j ACCEPT
../packet-filter/userspace/iptables -A PPP -s 212.160.112.131 -j ACCEPT
../packet-filter/userspace/iptables -A PPP -s 212.244.102.188 -j ACCEPT
../packet-filter/userspace/iptables -A PPP -p tcp --dport :1023 -j LOGDROP
../packet-filter/userspace/iptables -A PPP -p udp --dport :1023 -j LOGDROP
../packet-filter/userspace/iptables -A LOGDROP -j LOG
../packet-filter/userspace/iptables -A LOGDROP -j DROP

../packet-filter/userspace/iptables -L -n > $TMPFILE

# 5 chains = 10 intro lines + 4 spacers = 14 lines.
# 14 rules = 14 lines.
if [ `wc -l < $TMPFILE` != 28 ]
then
    echo Bad iptables -L: `wc -l < $TMPFILE` lines
    cat $TMPFILE
    exit 1
fi

../packet-filter/userspace/iptables -F

rmmod ipt_LOG
rmmod ipt_icmp
rmmod ipt_tcp
rmmod ipt_udp

exit 0
