#! /bin/sh
# Testing loop detection.

# Need job control.
set -m

# First, a new chain.
../packet-filter/userspace/iptables -N foo || exit 1

# Jumped to from FORWARD and INPUT.
../packet-filter/userspace/iptables -A FORWARD -j foo || exit 1
../packet-filter/userspace/iptables -A INPUT -j foo || exit 1

# Jumped to from FORWARD twice.
../packet-filter/userspace/iptables -A FORWARD -j foo || exit 1

# Jumps to another chain
../packet-filter/userspace/iptables -N foo2 || exit 1
../packet-filter/userspace/iptables -A foo -j foo2 || exit 1

# Which is also jumped to by the FORWARD and INPUT chains...
../packet-filter/userspace/iptables -A FORWARD -j foo2 || exit 1
../packet-filter/userspace/iptables -A INPUT -j foo2 || exit 1

# Now try inserting loop.
../packet-filter/userspace/iptables -A foo2 -j foo 2>/dev/null && exit 1

# Inserting loop which is never jumped to from builtin is OK.
../packet-filter/userspace/iptables -F INPUT || exit 1
../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A foo2 -j foo || exit 1

# But connecting it up will fail.
../packet-filter/userspace/iptables -A INPUT -j foo 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A FORWARD -j foo 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A OUTPUT -j foo 2>/dev/null && exit 1

../packet-filter/userspace/iptables -A INPUT -j foo2 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A FORWARD -j foo2 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A OUTPUT -j foo2 2>/dev/null && exit 1

# Even indirectly.
../packet-filter/userspace/iptables -N foo3 || exit 1
../packet-filter/userspace/iptables -A foo3 -j foo || exit 1

../packet-filter/userspace/iptables -A INPUT -j foo3 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A FORWARD -j foo3 2>/dev/null && exit 1
../packet-filter/userspace/iptables -A OUTPUT -j foo3 2>/dev/null && exit 1

exit 0
