#! /bin/sh

# Note that this tests the INSTALLED shared libs, not the ones in the
# tree.

# Need job control.
set -m

# Test the various options for the LOG target.
insmod ../packet-filter/extensions/ipt_LOG.o || exit 1

for j in "" "--log-level 0" "--log-level 7" "--log-level emerg" "--log-level alert" "--log-level crit" "--log-level err" "--log-level warning" "--log-level notice" "--log-level info" "--log-level debug"
do
    for k in "" "--log-prefix x" "--log-prefix testing:"
    do
	../packet-filter/userspace/iptables -A FORWARD -j LOG $i $j $k || exit 1
    done
done

# Message too long should fail
../packet-filter/userspace/iptables -A FORWARD -j LOG --log-prefix 1234567890123 || exit 1
../packet-filter/userspace/iptables -A FORWARD -j LOG --log-prefix 12345678901234 2>/dev/null && exit 1

# Send a packet through, check logs.
../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A FORWARD -j LOG --log-level 7 --log-prefix foobar: || exit 1
../packet-filter/userspace/iptables -A FORWARD -j LOG --log-level 0 || exit 1

dmesg -c >/dev/null
../tools/gen_ip $TAP0NET.2 $TAP1NET.4 100 1 8 0 56 58 > /dev/tap0 || exit 1
if [ "`dmesg | grep -v ^nf_iterate`" != "foobar:IN=tap0 OUT=tap1 SRC=$TAP0NET.2 DST=$TAP1NET.4 LEN=100 TOS=0x00 PREC=0x00 TTL=254 ID=0 PROTO=ICMP TYPE=8 CODE=0 ID=56 SEQ=58 
IN=tap0 OUT=tap1 SRC=$TAP0NET.2 DST=$TAP1NET.4 LEN=100 TOS=0x00 PREC=0x00 TTL=254 ID=0 PROTO=ICMP TYPE=8 CODE=0 ID=56 SEQ=58 " ]
then
    echo Bad message: \`"`dmesg | grep -v ^nf_iterate`"\'.
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
rmmod ipt_LOG || exit 1

exit 0
