#! /bin/sh
# Shell script to run iptables test suite.

START_FILE=$1
for f in 01iptables/[0-9]*
do
    if [ -z "$START_FILE" -o $f = "$START_FILE" ]
    then
	insmod ../packet-filter/kernel/iptables.o || exit 1

	if $f
	then
	    [ -z "$VERBOSE" ] || echo Test $f succeeded.
	else
	    echo Test $f failed.
	    exit 1
	fi
	rmmod iptables || exit 1
	logs_check $f

	START_FILE=""
    else
	[ -z "$VERBOSE" ] || echo Skipping test $f.
    fi
done

exit 0
