#! /bin/sh

# Script to test local UDP fragments go out fine.

# Need job control.
set -m

../tools/rcv_ip 4 2 < /dev/tap0 > $TMPFILE &
sleep 1

# This takes a while to complete
ping -c 1 -s 2000 $TAP0NET.2 >/dev/null 2>/dev/null &
sleep 1

if [ `wc -l < $TMPFILE` == 2 ]; then :
else
    echo Frags missing:
    cat $TMPFILE
    exit 1
fi

# Was it tracked properly?
if grep "^icmp     1 [0-9]* src=$TAP0 dst=$TAP0NET.2 type=8 code=0 id=[0-9]* \[UNREPLIED\] src=$TAP0NET.2 dst=$TAP0 type=0 code=0 id=[0-9]* $" < /proc/net/ip_conntrack > /dev/null
then
    :
else
    echo ICMP not tracked properly:
    cat /proc/net/ip_conntrack
    exit 1
fi

exit 0
