#! /bin/sh 

# Test that packets don't get mangled when no NAT in place.

# Need job control.
set -m

../tools/rcv_ip 2 `expr 15 \* 15 \* 2 \* 2` < /dev/tap0 > $TMPFILE &
sleep 1

[ -z "$VERBOSE" ] || echo $0 Phase 1: sending UDP packets.

# Test UDP ports across 2 src and dest IP addresses, in order.
for src in 2 3
do
    for dst in 2 3
    do
	for sp in 1 2 4 8 16 32 64 128 256 512 1023 1024 1025 4096 65535
	do 
	    for dp in 1 2 4 8 16 32 64 128 256 512 1023 1024 1025 4096 65535
	    do
		../tools/gen_ip $TAP1NET.$src $TAP0NET.$dst 100 17 $sp $dp > /dev/tap1
	    done
        done
    done
done

if wait %../tools/rcv_ip; then :
else
    echo rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

[ -z "$VERBOSE" ] || echo $0 Phase 2: checking UDP packets.

# Check results
for src in 2 3
do
    for dst in 2 3
    do
	for sp in 1 2 4 8 16 32 64 128 256 512 1023 1024 1025 4096 65535
	do 
	    for dp in 1 2 4 8 16 32 64 128 256 512 1023 1024 1025 4096 65535
	    do
		read LINE
		if [ "$LINE" != "$TAP1NET.$src $TAP0NET.$dst 100 17 $sp $dp" ]
		then
		    echo \`"$LINE"\' \!= \`"$TAP1NET.$src $TAP0NET.$dst 100 17 $sp $dp"\'
		    exit 1
		fi
	    done
        done
    done
done < $TMPFILE

exit 0
