#! /bin/sh

# Test that simple IP RNAT works.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.0/24 -d $TAP1NET.2 -b dest -t $TAP1NET.3 || exit 1

../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.0/24 -d $TAP1NET.2 -b dest -t $TAP1NET.3 || exit 1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

OUTPUT=`cat $TMPFILE`
if [ "$OUTPUT" != "$TAP0NET.2 $TAP1NET.3 100 1 8 0 55 57 " ]
then
    echo Unexpected output: $OUTPUT
    exit 1
fi

exit 0

