#! /bin/sh

# Test for simple IP RNAT replies.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -t $TAP0NET.3 || exit 1

# ICMP, UDP, TCP and unknown
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 53 53 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 8080 SYN > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 2 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.2 -b source -t $TAP0NET.3 || exit 1

# Send four replies: should be mirrored back.
../tools/rcv_ip 2 4 < /dev/tap0 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP1NET.2 $TAP0NET.3 100 1 0 0 55 57 > /dev/tap1
../tools/gen_ip $TAP1NET.2 $TAP0NET.3 100 17 53 53 > /dev/tap1
../tools/gen_ip $TAP1NET.2 $TAP0NET.3 100 6 8080 1024 SYN/ACK > /dev/tap1
../tools/gen_ip $TAP1NET.2 $TAP0NET.3 100 2 > /dev/tap1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP1NET.2 $TAP0NET.2 100 1 0 0 55 57" \
	      "$TAP1NET.2 $TAP0NET.2 100 17 53 53" \
	      "$TAP1NET.2 $TAP0NET.2 100 6 8080 1024 SYN/ACK" \
	      "$TAP1NET.2 $TAP0NET.2 100 2"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected answer "$LINE"
	exit 1
    fi
done < $TMPFILE

exit 0

