#! /bin/sh

# Tests for the UDP parts of ip nat rules.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --sport 1 --dport 2 || exit 1

# Receive four packets.
../tools/rcv_ip 2 4 < /dev/tap1 > $TMPFILE &
sleep 1

# Only one of these should match.
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 1 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 1 2 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 2 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 2 2 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --sport 1 --dport 2 || exit 1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP0NET.2 $TAP1NET.2 100 17 1 1" \
	      "$TAP0NET.4 $TAP1NET.2 100 17 1 2" \
	      "$TAP0NET.2 $TAP1NET.2 100 17 2 1" \
	      "$TAP0NET.2 $TAP1NET.2 100 17 2 2"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected answer "$LINE"
	exit 1
    fi
done < $TMPFILE

exit 0
