#! /bin/sh

# Test the case where the NAT space fills up (packets should be dropped).

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --to-ports 1-10 || exit 1

# Receive 10 packets.
../tools/rcv_ip 2 10 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 100 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 101 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 102 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 103 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 104 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 105 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 106 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 107 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 108 1 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 109 1 > /dev/tap0

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP0NET.4 $TAP1NET.2 100 17 1 1 
$TAP0NET.4 $TAP1NET.2 100 17 2 1 
$TAP0NET.4 $TAP1NET.2 100 17 3 1 
$TAP0NET.4 $TAP1NET.2 100 17 4 1 
$TAP0NET.4 $TAP1NET.2 100 17 5 1 
$TAP0NET.4 $TAP1NET.2 100 17 6 1 
$TAP0NET.4 $TAP1NET.2 100 17 7 1 
$TAP0NET.4 $TAP1NET.2 100 17 8 1 
$TAP0NET.4 $TAP1NET.2 100 17 9 1 
$TAP0NET.4 $TAP1NET.2 100 17 10 1 " ]
then
    echo Unexpected output from rcv_ip:
    cat $TMPFILE
    exit 1
fi

# Shouldn't receive 11th packet.
../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 17 110 1 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --to-ports 1-10 || exit 1

if wait %../tools/rcv_ip
then 
    echo ../tools/rcv_ip succeeded:
    cat $TMPFILE
    exit 1
fi


exit 0


