#! /bin/sh

# Tests for masquerading.

# Need job control.
set -m

insmod ../NAT/mapping-types/ip_nat_map_masquerade.o || exit 1

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -m masquerade || exit 1

../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP1 $TAP1NET.2 100 1 8 0 55 57 " ]
then
    echo Bad rcv \`"`cat $TMPFILE`"\' v \`$TAP1 $TAP1NET.2 100 1 8 0 55 57 \'
    exit 1
fi

# Reply

../tools/rcv_ip 2 1 < /dev/tap0 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP1NET.2 $TAP1 100 1 0 0 55 57 > /dev/tap1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip of pong failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP1NET.2 $TAP0NET.2 100 1 0 0 55 57 " ]
then
    echo Bad rcv \`"`cat $TMPFILE`"\' v \`$TAP1NET.2 $TAP0NET.2 100 1 0 0 55 57 \'
    exit 1
fi

# Test deletion on interface down.
../tools/rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 56 58 > /dev/tap0

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip after ifdown failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP1 $TAP1NET.2 100 1 8 0 56 58 " ]
then
    echo Bad 2nd rcv \`"`cat $TMPFILE`"\'
    exit 1
fi

# Down interface and up again.
ifconfig tap1 down || exit 1
ifconfig tap1 $TAP1 || exit 1

# Reply should not be mapped.
../tools/rcv_ip 2 1 < /dev/tap0 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP1NET.2 $TAP1 100 1 0 0 56 58 > /dev/tap1

if wait %../tools/rcv_ip
then
    echo ../tools/rcv_ip of pong succeeded after interface downed:
    cat $TMPFILE
    exit 1
fi

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -m masquerade || exit 1
rmmod ip_nat_map_masquerade || exit 1

exit 0


