#! /bin/sh

# Tests for TCP NAT extensions.  FIXME: finish

# Need job control.
set -m

# Common mistake: invalid range (must use -).
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -p tcp -b source -t $TAP0NET.2 --to-port 1024:65535 2>/dev/null && exit 1

../NAT/userspace/ipnatctl -I -s $TAP0NET.0/24 -d $TAP1NET.2 -p tcp --sport 100 --dport 101 -b source -t $TAP0NET.3 --to-port 2000-2001 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.0/24 -d $TAP1NET.2 -p tcp --sport 100 --dport 101 -b source -t $TAP0NET.3 --to-port 1024 || exit 1

../tools/rcv_ip 2 6 < /dev/tap1 > $TMPFILE &
sleep 1

# These should get assigned by NAT rules.
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 100 101 SYN > /dev/tap0
../tools/gen_ip $TAP0NET.4 $TAP1NET.2 100 6 100 101 SYN > /dev/tap0
../tools/gen_ip $TAP0NET.5 $TAP1NET.2 100 6 100 101 SYN > /dev/tap0

# This one misses out
../tools/gen_ip $TAP0NET.6 $TAP1NET.2 100 6 100 101 SYN > /dev/tap0

# These should miss the NAT rules.
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 102 101 SYN > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 100 103 SYN > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 102 103 SYN > /dev/tap0

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

# Backwards assignment at the moment.
for LINE in "$TAP0NET.3 $TAP1NET.2 100 6 1024 101 SYN" \
	"$TAP0NET.3 $TAP1NET.2 100 6 2001 101 SYN" \
	"$TAP0NET.3 $TAP1NET.2 100 6 2000 101 SYN" \
	"$TAP0NET.2 $TAP1NET.2 100 6 102 101 SYN" \
	"$TAP0NET.2 $TAP1NET.2 100 6 100 103 SYN" \
	"$TAP0NET.2 $TAP1NET.2 100 6 102 103 SYN"
do
    read ACTUAL
    if [ "$ACTUAL" != "$LINE" ]
    then
	echo Expected \`"$LINE"\' not \`"$ACTUAL"\'.
	cat $TMPFILE
	exit 1
    fi
done < $TMPFILE

exit 0
