#! /bin/sh

# Start connections, THEN insert NAT module (enlarges conntrack size).

rmmod ip_nat || exit 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 100 1 SYN > /dev/tap0 || exit 1

# Should have one conntrack now.
if grep "^tcp      6 [0-9]* SYN_SENT src=$TAP0NET.2 dst=$TAP1NET.2 sport=100 dport=1 \[UNREPLIED\] src=$TAP1NET.2 dst=$TAP0NET.2 sport=1 dport=100 $" < /proc/net/ip_conntrack > /dev/null || [ `wc -l < /proc/net/ip_conntrack` != 1 ]
then :
else
    echo TCP didn\'t create conntrack:
    cat /proc/net/ip_conntrack
    exit 1
fi

insmod ../NAT/ip_nat.o || exit 1

if grep "^tcp      6 [0-9]* SYN_SENT src=$TAP0NET.2 dst=$TAP1NET.2 sport=100 dport=1 \[UNREPLIED\] src=$TAP1NET.2 dst=$TAP0NET.2 sport=1 dport=100 $" < /proc/net/ip_conntrack > /dev/null || [ `wc -l < /proc/net/ip_conntrack` != 1 ]
then :
else
    echo Conntrack lost after nat insert:
    cat /proc/net/ip_conntrack
    exit 1
fi

# Still OK after retrans?
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 100 1 SYN > /dev/tap0 || exit 1

if grep "^tcp      6 [0-9]* SYN_SENT src=$TAP0NET.2 dst=$TAP1NET.2 sport=100 dport=1 \[UNREPLIED\] src=$TAP1NET.2 dst=$TAP0NET.2 sport=1 dport=100 $" < /proc/net/ip_conntrack > /dev/null || [ `wc -l < /proc/net/ip_conntrack` != 1 ]
then :
else
    echo Conntrack lost after tcp retransmit:
    cat /proc/net/ip_conntrack
    exit 1
fi

exit 0
