#! /bin/sh

# Script to test ftp module's data mangling

# Need job control.
set -m

insmod ../conntrack/extensions/ip_conntrack_ftp.o || exit 1
insmod ../NAT/extensions/ip_nat_ftp.o || exit 1

# Normal NAT test.
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -b source -t $TAP0NET.100 || exit 1

# Generate initial packets: handshake, then FTP PORT command.
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
../tools/gen_ip $TAP1NET.2 $TAP0NET.100 100 6 21 1024 SYN/ACK > /dev/tap1 || exit 1
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK > /dev/tap0 || exit 1

../tools/rcv_ip 2 1 DATA < /dev/tap1 > $TMPFILE &
sleep 1

echo -e "PORT `echo $TAP0NET.2 | tr . ,`,7,236\\r" |
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK DATA > /dev/tap0 || exit 1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`tr \\\r x < $TMPFILE`" != "$TAP0NET.100 $TAP1NET.2 66 6 1024 21 ACK DATA
PORT `echo $TAP0NET.100 | tr . ,`,7,236x" ]
then
    echo Unexpected FTP PORT mangling.
    echo \`"`tr \\\r x <  $TMPFILE`"\'
    cat /proc/net/ip_conntrack
    exit 1
fi

# Force timeout of TCP connections.
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 RST > /dev/tap0 || exit 1
sleep 10

rmmod ip_nat_ftp || exit 1
rmmod ip_conntrack_ftp || exit 1

exit 0
