#! /bin/sh

# Tests for null NAT extension.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.3 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.3 -b source -m null || exit 1

if [ "`cat /proc/net/ip_nat_rules`" != "null [SRC] $TAP0NET.2/32->$TAP1NET.3/32 TO: 
generic [SRC] $TAP0NET.2/32->$TAP1NET.0/24 TO: $TAP0NET.3 " ]
then
    echo Unexpected rules: \`"`cat /proc/net/ip_nat_rules`"\'
    exit 1
fi

../tools/rcv_ip 2 2 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
../tools/gen_ip $TAP0NET.2 $TAP1NET.3 100 1 8 0 56 58 > /dev/tap0

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP0NET.3 $TAP1NET.2 100 1 8 0 55 57 
$TAP0NET.2 $TAP1NET.3 100 1 8 0 56 58 " ]
then
    echo Bad rcv \`"`cat $TMPFILE`"\'
    exit 1
fi

exit 0
