#! /bin/sh
# Shell script to run NAT test suite.

START_FILE=$1
for f in 03NAT/[0-9]*
do
    if [ -z "$START_FILE" -o $f = "$START_FILE" ]
    then
	insmod ../conntrack/ip_conntrack.o || exit 1
	insmod ../NAT/ip_nat.o || exit 1

	if $f
	then
	    [ -z "$VERBOSE" ] || echo Test $f succeeded.
	else
	    echo Test $f failed.
	    exit 1
	fi
	rmmod ip_nat || exit 1
	rmmod ip_conntrack || exit 1

	logs_check $f
	START_FILE=""
    else
	[ -z "$VERBOSE" ] || echo Skipping test $f.
    fi
done

exit 0
