#! /bin/sh

# Simple REDIRECT; check that it works.

# Need job control.
set -m

# In fact, without real NAT, this RST trick didn't work.
ipchains -A input -p tcp -d $TAP1NET.2 -j REDIRECT || exit 1
ipchains -A input -p tcp -d $TAP1NET.3 --dport 5555 -j REDIRECT 5556 || exit 1
ipchains -A input -p tcp -d $TAP1NET.3 --dport 5558 -j REDIRECT 5555 || exit 1

# If we hit this netcat, we'll get a SYN/ACK, otherwise RST.
echo Hello | nc -l -p 5555 -w 10 &

../tools/rcv_ip 2 3 < /dev/tap0 > $TMPFILE &
sleep 1

# Send SYN (hit first rule).
../tools/gen_ip $TAP0NET.2 $TAP1NET.2 40 6 1024 5556 SYN > /dev/tap1 || exit 1
# Second rule
../tools/gen_ip $TAP0NET.2 $TAP1NET.3 40 6 1024 5555 SYN > /dev/tap1 || exit 1
# Third rule
../tools/gen_ip $TAP0NET.2 $TAP1NET.3 40 6 1024 5558 SYN > /dev/tap1 || exit 1

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ `wc -l < $TMPFILE` != 3 ]
then
    echo Unexpected number of lines:
    echo \`"`cat $TMPFILE`"\'
    exit 1
fi    

if [ "`head -2 $TMPFILE`" != "$TAP1NET.2 $TAP0NET.2 40 6 5556 1024 RST ACK=1 
$TAP1NET.3 $TAP0NET.2 40 6 5555 1024 RST ACK=1 " ]
then
    echo Unexpected result:
    echo \`"`cat $TMPFILE`"\'
    exit 1
fi

if tail +3 $TMPFILE | grep "^$TAP1NET.3 $TAP0NET.2 44 6 5558 1024 SYN/ACK OPT=2,4,5,180 SYN=[0-9]* ACK=1 $" > /dev/null
then
    :
else
    echo Unexpected last line:
    echo \`"`cat $TMPFILE`"\'
    exit 1
fi

wait

exit 0
